// ============================================================
// Project				:	CityRPG
// Author				:	Iban & Jookia
// Description			:	Civilian Code file
// ============================================================
// Table of Contents
// 1. Handling Script Start
// 2. Lots
// 2.2 Sale Lots
// 3. Data Bricks
// 4. Spawns
// 5. Resources
// 6. Other
// ============================================================

// ============================================================
// Section 1 : Handling Script Start
// ============================================================
$CityRPG::temp::brickError = forceRequiredAddOn("player_no_jet");

if($CityRPG::temp::brickError)
{
	if($CityRPG::temp::brickError == $error::addOn_disabled)
		playerNoJet.uiName = "";
	
	if($CityRPG::temp::brickError == $error::addOn_notFound)
		return;
}

$CityRPG::loadedDatablocks = true;

if(!$CityRPG::loadedDatablocks)
{
	return;
}

datablock triggerData(CityRPGLotTriggerData)
{
	tickPeriodMS = 500;
	parent = 0;
};

datablock triggerData(CityRPGInputTriggerData)
{
	tickPeriodMS = 500;
	parent = 0;
};


// ============================================================
// Section 2 : Lots
// ============================================================
datablock fxDTSBrickData(CityRPGSmallLotBrickData : brick16x16FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/16x16LotIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Lots";
	
	uiName = "Small Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 16 48";
	trigger = 0;
	
	initialPrice = 500;
	taxAmount = 10;
};

datablock fxDTSBrickData(CityRPGHalfSmallLotBrickData : brick16x32FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/16x32LotIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Lots";
	
	uiName = "Half-Small Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 32 48";
	trigger = 0;
	
	initialPrice = 1000;
	taxAmount = 20;
};

datablock fxDTSBrickData(CityRPGMediumLotBrickData : brick32x32FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/32x32LotIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Lots";
	
	uiName = "Medium Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "32 32 64";
	trigger = 0;
	
	initialPrice = 2000;
	taxAmount = 40;
};

datablock fxDTSBrickData(CityRPGLargeLotBrickData : brick64x64FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/64x64LotIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Lots";
	
	uiName = "Large Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "64 64 128";
	trigger = 0;
	
	initialPrice = 8000;
	taxAmount = 80;
};

datablock fxDTSBrickData(CityRPGSmalltLotBrickData : brick16x16FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/16x16IndLotIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Lots";
	
	uiName = "Small Taxless Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 16 96";
	trigger = 0;
	
	initialPrice = 750;
	taxAmount = 0;
};

datablock fxDTSBrickData(CityRPGHalfSmalltLotBrickData : brick16x32FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/16x32IndLotIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Lots";
	
	uiName = "Half-Small Taxless Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "16 32 96";
	trigger = 0;
	
	initialPrice = 1500;
	taxAmount = 0;
};

datablock fxDTSBrickData(CityRPGMediumtLotBrickData : brick32x32FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/32x32IndLotIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Lots";
	
	uiName = "Medium Taxless Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "32 32 128";
	trigger = 0;
	
	initialPrice = 3000;
	taxAmount = 0;
};

datablock fxDTSBrickData(CityRPGLargetLotBrickData : brick64x64FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/64x64IndLotIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Lots";
	
	uiName = "Large Taxless Lot";
	
	CityRPGBrickType = 1;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGLotTriggerData;
	triggerSize = "64 64 256";
	trigger = 0;
	
	initialPrice = 12000;
	taxAmount = 0;
};

// Sale Lots
datablock fxDTSBrickData(CityRPGSmallZoneBrickData : brick16x16FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/16x16ZoneIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Zones";
	
	uiName = "Small Zone";

	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGSmallLotBrickData;
};

datablock fxDTSBrickData(CityRPGHalfSmallZoneBrickData : brick16x32FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/16x32ZoneIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Zones";
	
	uiName = "Half-Small Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGHalfSmallLotBrickData;
};

datablock fxDTSBrickData(CityRPGMediumZoneBrickData : brick32x32FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/32x32ZoneIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Zones";
	
	uiName = "Medium Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGMediumLotBrickData;
};

datablock fxDTSBrickData(CityRPGLargeZoneBrickData : brick64x64FData)
{
	iconName = "Add-Ons/GameMode_CityRPG/bricks/lots/64x64ZoneIcon";
	
	category = "Baseplates";
	subCategory = "CityRPG Zones";
	
	uiName = "Large Zone";
	
	CityRPGBrickAdmin = true;
	CityRPGMatchingLot = CityRPGLargeLotBrickData;
};

// ============================================================
// Section 3 : Data Bricks
// ============================================================
exec("./bricks/info/atm.cs");
exec("./bricks/info/bank.cs");
exec("./bricks/info/police.cs");
exec("./bricks/info/bounty.cs");
exec("./bricks/info/labor.cs");
exec("./bricks/info/realestate.cs");
exec("./bricks/info/drugsell.cs");

// ============================================================
// Section 4 : Spawns
// ============================================================
datablock fxDtsBrickData(CityRPGPersonalSpawnBrickData : brickSpawnPointData)
{
	category = "CityRPG";
	subCategory = "CityRPG Spawns";
	
	uiName = "Personal Spawn";
	
	specialBrickType = "";
	
	CityRPGBrickType = 3;
	CityRPGBrickAdmin = false;
	
	spawnData = "personalSpawn";
};

datablock fxDtsBrickData(CityRPGJailSpawnBrickData : brickSpawnPointData)
{
	category = "CityRPG";
	subCategory = "CityRPG Spawns";
	
	uiName = "Jail Spawn";
	
	specialBrickType = "";
	
	CityRPGBrickType = 3;
	CityRPGBrickAdmin = true;
	
	spawnData = "jailSpawn";
};

// ============================================================
// Section 5 : Resources
// ============================================================
exec("./bricks/resources/tree.cs");
exec("./bricks/resources/ore/ore.cs");
exec("./bricks/resources/smallore/smallore.cs");

// ============================================================
// Section 6 : Other
// ============================================================
exec("./bricks/drugs/drugs.cs");

datablock fxDTSBrickData(CityRPGPermaSpawnData : brick2x2FData)
{
	category = "CityRPG";
	subCategory = "CityRPG Infoblocks";
	
	uiName = "Permaspawn Brick";

	CityRPGBrickAdmin = true;
	CityRPGPermaspawn = 1;
};

datablock fxDTSBrickData(CityRPGPoliceVehicleData : brickVehicleSpawnData)
{
	category = "CityRPG";
	subCategory = "CityRPG Spawns";
	uiName = "Police Vehicle Spawn";
	CityRPGBrickAdmin = true;
};