// ============================================================
// Project				:	CityRPG
// Author				:	Aoki
// Description			:	Drugs Code File
// ============================================================
// Table of Contents
// 1. Prefs
// 2. Brick Data
// ============================================================
$CityRPG::Drugs::minSellingSpeed = 1;
$CityRPG::Drugs::maxSellingSpeed = 5;
$CityRPG::Drugs::minBuyAmt = 1;
$CityRPG::Drugs::maxBuyAmt = 25;
$CityRPG::Drugs::DrugLimit = 8;
$CityRPG::Drugs::evidenceWorth = 6;
$CityRPG::Drugs::demWorth = 1.5;
$CityRPG::DrugCount = 0;
$CityRPG::Drug[$CityRPG::DrugCount++] = "Cannabis";
$CityRPG::Drug[$CityRPG::DrugCount++] = "Peyote";
$CityRPG::Drug[$CityRPG::DrugCount++] = "Shrooms";
$CityRPG::Drug[$CityRPG::DrugCount++] = "Tobacco";

// ============================================================
// Section 1 : Prefs
// ============================================================
$CityRPG::Drugs::priceCannabis = 1800;
$CityRPG::Drugs::HarvestMinCannabis = 9;
$CityRPG::Drugs::HarvestMaxCannabis = 14;
$CityRPG::Drugs::growthTimeCannabis = 2;
$CityRPG::Drugs::MinSellCannabis = 13;
$CityRPG::Drugs::MaxSellCannabis = 14;

$CityRPG::Drugs::pricePeyote = 3000;
$CityRPG::Drugs::HarvestMinPeyote = 11;
$CityRPG::Drugs::HarvestMaxPeyote = 18;
$CityRPG::Drugs::growthTimePeyote = 2;
$CityRPG::Drugs::MinSellPeyote = 15;
$CityRPG::Drugs::MaxSellPeyote = 16;

$CityRPG::Drugs::priceShrooms = 1000;
$CityRPG::Drugs::HarvestMinShrooms = 7;
$CityRPG::Drugs::HarvestMaxShrooms = 10;
$CityRPG::Drugs::growthTimeShrooms = 1.5;
$CityRPG::Drugs::MinSellShrooms = 9;
$CityRPG::Drugs::MaxSellShrooms = 12;

$CityRPG::Drugs::priceTobacco = 1500;
$CityRPG::Drugs::HarvestMinTobacco = 8;
$CityRPG::Drugs::HarvestMaxTobacco = 16;
$CityRPG::Drugs::growthTimeTobacco = 2;
$CityRPG::Drugs::MinSellTobacco = 10;
$CityRPG::Drugs::MaxSellTobacco = 14;
// ============================================================
// Section 2 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPGCannabisData)
{
	brickFile = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Cannabis/brick.blb";
	iconName = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Cannabis/icon";
	collisionShapeName = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Cannabis/shape.dts";

	uiName = "Cannabis";
	category = "CityRPG";
	subCategory = "Drugs";

	CityRPGBrickType = 420;
	initialPrice = $CityRPG::Drugs::priceCannabis;
};

datablock fxDTSBrickData(CityRPGPeyoteData)
{
	brickFile = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Peyote/brick.blb";
	iconName = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Peyote/icon";
	collisionShapeName = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Peyote/shape.dts";

	uiName = "Peyote";
	category = "CityRPG";
	subCategory = "Drugs";

	CityRPGBrickType = 420;
	initialPrice = $CityRPG::Drugs::pricePeyote;
};

datablock fxDTSBrickData(CityRPGShroomsData)
{
	brickFile = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Shrooms/brick.blb";
	iconName = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Shrooms/icon";

	uiName = "Shrooms";
	category = "CityRPG";
	subCategory = "Drugs";

	CityRPGBrickType = 420;
	initialPrice = $CityRPG::Drugs::priceShrooms;
};

datablock fxDTSBrickData(CityRPGTobaccoData)
{
	brickFile = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Tobacco/brick.blb";
	iconName = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Tobacco/icon";
	collisionShapeName = "Add-Ons/Gamemode_CityRPG/bricks/drugs/Tobacco/shape.dts";

	uiName = "Tobacco";
	category = "CityRPG";
	subCategory = "Drugs";

	CityRPGBrickType = 420;
	initialPrice = $CityRPG::Drugs::priceTobacco;
};

function fxDTSBrick::startGrowing(%brick)
{
	%brickData = %brick.getDatablock();
	%brick.color = 45 + %brick.growTime;
	%drugType = $CityRPG::Drugs::growthTime[%brickData.uiName];
	%drugTime = %drugType * 7500;

	if(%brick.growTime < 8)
	{
		%brick.setColor(%brick.color);
		%brick.setEmitter(None);
		%brick.growTime++;
		%brick.schedule(%drugTime, "startGrowing", %brick);
	}
	else if(%brick.growTime == 8)
		%brick.grow();
}

function fxDTSBrick::grow(%brick)
{
	%brick.health = 0;
	%brick.grown = 1;
	%brick.setColor(61);
	%brick.drugEmitter = GunSmokeEmitter;
	%brick.setEmitter(%brick.drugEmitter);
}

function fxDTSBrick::harvest(%brick, %client)
{
	%brickData = %brick.getDatablock();

	if(!%brick.grown)
		return false;

	if(%brick.health < %brick.random)
	{
		%brick.health++;
		%percentage = mFloor((%brick.health / %brick.random) * 100);
			
		// cool color effect
		if(%percentage >= 0 && %percentage < 10)
			%color = "<color:ff0000>";
		else if(%percentage >= 10 && %percentage < 20)
			%color = "<color:ff2200>";
		else if(%percentage >= 10 && %percentage < 30)
			%color = "<color:ff4400>";
		else if(%percentage >= 10 && %percentage < 40)
			%color = "<color:ff6600>";
		else if(%percentage >= 10 && %percentage < 50)
			%color = "<color:ff8800>";
		else if(%percentage >= 10 && %percentage < 60)
			%color = "<color:ffff00>";
		else if(%percentage >= 10 && %percentage < 70)
			%color = "<color:88ff00>";
		else if(%percentage >= 10 && %percentage < 80)
			%color = "<color:66ff00>";
		else if(%percentage >= 10 && %percentage < 90)
			%color = "<color:44ff00>";
		else if(%percentage >= 10 && %percentage < 100)
			%color = "<color:22ff00>";
		else if(%percentage == 100)
			%color = "<color:00ff00>";

		commandToClient(%client,'centerPrint',"\c3" @ %brickData.uiName @ " \c6harvested: %" @ %color @ "" @ %percentage,3);
		return;
	}

	%harvestAmt = getRandom($CityRPG::Drugs::HarvestMin[%brickData.uiName], $CityRPG::Drugs::HarvestMax[%brickData.uiName]);
	CityRPGData.getData(%client.bl_id).value[%brickData.uiName] += %harvestAmt;
	%client.centerPrint("\c6You have harvested\c3" SPC %harvestAmt SPC "\c6grams of\c3" SPC %brickData.uiName @ "\c6.", 3);

	%brick.currentColor = 45;
	%brick.setColor(%brick.currentColor);
	%brick.grown = false;
	%brick.health = 0;
	%brick.growTime = 0;
	%brick.watered = 0;
	%brick.random = getRandom($CityRPG::Drugs::HarvestMin[%brickData.uiName], $CityRPG::Drugs::HarvestMax[%brickData.uiName]);
	%brick.drugEmitter = "None";
	%brick.setEmitter(None);
	%client.setInfo();
}

function gameConnection::startSelling(%client, %drug)
{
	%amount = CityRPGData.getData(%client.bl_id).value[%drug];

	if(%amount <= 0)
	{
		messageClient(%client, '', "\c6You're all out!");
		return 0;
	}
	else
		%client.drugTick = %client.schedule((getRandom($CityRPG::Drugs::minSellingSpeed, $CityRPG::Drugs::maxSellingSpeed) * 1000), "startSelling", %drug);
	

	%grams = getRandom($CityRPG::Drugs::minBuyAmt, $CityRPG::Drugs::maxBuyAmt);

	if(%grams > %amount)
		%grams = %amount;

	%profit = getRandom($CityRPG::Drugs::minSell[%drug], $CityRPG::Drugs::maxSell[%drug]);

	%cash = %grams * %profit;

	%random = getRandom(1, 2);

	if(%random == 1)
		%cash -= getRandom(0.75, 1);
	else
		%cash += getRandom(1, 1.25);

	%cash = mFloor(%cash);

	CityRPGData.getData(%client.bl_id).valueMoney += %cash;
	%client.setInfo();

	%slang = %grams;
	switch(%slang)
	{
		case 1:
			%slang = "a \c3gram\c6 of";
		case 2:
			%slang = "a \c3dimebag\c6 of";
		case 3:
			%slang = "\c3three grams\c6 of";
		case 4:
			%slang = "a \c3dub\c6 of";
		case 5:
			%slang = "\c3five grams\c6 of";
		default:
			%slang = "some";
	}

	messageClient(%client, '', "\c6You sold " @ %slang SPC %drug SPC "to a stranger for \c3$" @ %cash @"\c6.");

	CityRPGData.getData(%client.bl_id).value[%drug] -= %grams;
}

function servercmdmyDrugs(%client, %time)
{
	if(%time $= "")
		%time = 5;

	%cent = "<just:left>\c3Cannabis\c6:" SPC CityRPGData.getData(%client.bl_id).valueCannabis;
	%cent = %cent @ "<br>\c3Peyote\c6:" SPC CityRPGData.getData(%client.bl_id).valuePeyote;
	%cent = %cent @ "<br>\c3Shrooms\c6:" SPC CityRPGData.getData(%client.bl_id).valueShrooms;
	%cent = %cent @ "<br>\c3Tobacco\c6:" SPC CityRPGData.getData(%client.bl_id).valueTobacco;
	%client.centerPrint(%cent, %time);
}

function gameConnection::getDrugCount(%client)
{
	%totalDrugs = 0;

	for(%a = 1; %a <= $CityRPG::DrugCount; %a++)
		%totalDrugs += CityRPGData.getData(%client.bl_id).value[$CityRPG::Drug[%a]];

	return %totalDrugs;
}

function fxDTSBrick::bagPlant(%brick, %client)
{
	%brickData = %brick.getDatablock();

	%harvestAmt = getRandom($CityRPG::Drugs::HarvestMin[%brickData.uiName], $CityRPG::Drugs::HarvestMax[%brickData.uiName]);
	CityRPGData.getData(%client.bl_id).valueEvidence += %harvestAmt;
	messageClient(%client, '', "\c6You take" SPC %harvestAmt SPC "grams of" SPC %brickData.uiName SPC "as evidence.");
	%brick.schedule(0, "delete");
}