// ============================================================
// Project				:	CityRPG
// Author				:	Iban & Jookia
// Description				:	ATM Brick Code File
// ============================================================
// Table of Contents
// 1. Brick Data
// 2. Trigger Data
// ============================================================

// ============================================================
// Section 1 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPGATMBrickData : brick2x4FData)
{
	category = "CityRPG";
	subCategory = "CityRPG Infoblocks";
	
	uiName = "ATM Brick";
	
 	CityRPGBrickType = 2;
	CityRPGBrickAdmin = false;
	
	triggerDatablock = CityRPGInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

// ============================================================
// Section 2 : Trigger Data
// ============================================================
function CityRPGATMBrickData::parseData(%this, %brick, %client, %triggerStatus, %text)
{
	if(%triggerStatus !$= "")
	{
		if(%triggerStatus == true && %client.stage $= "")
		{
			messageClient(%client, '', "\c6ATM Online");
			if(CityRPGData.getData(%client.bl_id).valueBank > 0)
			{
				messageClient(%client, '', "\c6- You have \c3$" @ CityRPGData.getData(%client.bl_id).valueBank SPC "\c6in your account.");
			}
			
			messageClient(%client, '', "\c31 \c6- Withdraw Money.");
			
			%client.stage = 0;
		}
		
		if(%triggerStatus == false && %client.stage !$= "")
		{
			messageClient(%client, '', "\c6ATM Offline");
			
			%client.stage = "";
		}
		
		return;
	}
	
	%input = strLwr(%text);
	
	if(mFloor(%client.stage) == 0)
	{
		if(strReplace(%input, "1", "") !$= %input || strReplace(%input, "one", "") !$= %input)
		{
			%client.stage = 1.1;
			
			messageClient(%client, '', "\c6Enter the amount of money you wish to withdraw.");
			
			return;
		}
	}
	
	if(mFloor(%client.stage) == 1)
	{
		if(%client.stage == 1.1)
		{
			if(mFloor(%input) < 1)
			{
				messageClient(%client, '', "\c6Error.");
				
				return;
			}
			
			if(CityRPGData.getData(%client.bl_id).valueBank - mFloor(%input) < 0)
			{
				if(CityRPGData.getData(%client.bl_id).valueATM < 1)
				{
					messageClient(%client, '', "\c6Insufficient funds.");
					
					%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
					
					return;
				}
				
				%input = CityRPGData.getData(%client.bl_id).valueATM;
			}
			
			messageClient(%client, '', "\c6You have withdrawn \c3$" @ mFloor(%input) @ "\c6.");
			
			%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, (isObject(%client.player) ? %client.player : 0));
			
			CityRPGData.getData(%client.bl_id).valueBank -= mFloor(%input);
			CityRPGData.getData(%client.bl_id).valueMoney += mFloor(%input);
			
			%client.SetInfo();
		}
		return;
	}
}
	
//	if(mFloor(%client.stage) == 2)
//	{
//		if(%client.stage == 2.0)
//		{
//			messageClient(%client, '', "\c6Are you looking to \c3store\c6 or \c3take\c6 an item?");
//			return;
//		}
//		else if(%client.stage == 2.1)
//		{
//			messageClient(%client, '', "\c6Please enter in the ID matching the Item you want to store.");
//			
//			for(%a = 0; %a < %client.player.getDatablock().maxTools; %a++)
//			{
//				%tool = %client.player.tool[%a];
//				
//				if(isObject(%tool))
//				{
//					messageClient(%client, '', "\c3" @ %a @ "\c6 - \c3" @ %tool.uiName);
//				}
//				
//				return;
//			}
//		}
//	}
//}