// ============================================================
// Project				:	CityRPG
// Author				:	Iban, Jookia and Outpact
// Description			:	Drug Sell Brick Code File
// ============================================================
// Table of Contents
// 1. Brick Data
// 2. Trigger Data
// ============================================================

// ============================================================
// Section 1 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPGDrugSellBrickData : brick2x4FData)
{
	category = "CityRPG";
	subCategory = "CityRPG Infoblocks";
	
	uiName = "Drug Sell Brick";
	
	CityRPGBrickType = 2;
	initialPrice = 12000;
	
	triggerDatablock = CityRPGInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

// ============================================================
// Section 2 : Trigger Data
// ============================================================
function CityRPGDrugSellBrickData::parseData(%this, %brick, %client, %triggerStatus, %text)
{
	if(%triggerStatus !$= "")
	{
		if(%triggerStatus == true && %client.stage $= "")
		{
			messageClient(%client, '', "\c3What do you want to sell? \c6(New? /help sub drugs)");
			for(%a = 1; %a <= $CityRPG::DrugCount; %a++)
				messageClient(%client, '', "\c3" @ %a @ "\c6 - Sell" SPC $CityRPG::Drug[%a]);

			%client.stage = 0;
		}
		
		if(%triggerStatus == false && %client.stage !$= "")
		{
			cancel(%client.drugTick);
			messageClient(%client, '', "\c6You are no longer selling.");
			%client.stage = "";
		}
		
		return;
	}
	
	%input = strLwr(%text);
	
	if(mFloor(%client.stage) == 0)
	{
		if($CityRPG::Drug[%input] $= "")
		{
			messageClient(%client, '', "\c6What?");
			return;
		}

		if(CityRPGData.getData(%client.bl_id).value[$CityRPG::Drug[%input]] <= 0)
		{
			messageClient(%client, '', "\c6Come back when you have something to show.");
			return;
		}

		%client.startSelling($CityRPG::Drug[%input]);
	}
}