// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Ore Brick Code File
// ============================================================
// Table of Contents
// 1. Brick Data
// 2. Events
// ============================================================

// ============================================================
// Section 1 : Brick Data
// ============================================================
datablock fxDTSBrickData(CityRPGOreData)
{
	brickFile = "./brick.blb";
	iconName = "Add-Ons/Gamemode_CityRPG/bricks/resources/ore/icon";
	
	category = "CityRPG";
	subCategory = "CityRPG Resources";
	
	uiName = "Ore";
	
	CityRPGBrickType = 5;
	CityRPGBrickAdmin = true;
};

// ============================================================
// Section 2 : Events
// ============================================================
function fxDTSBrick::adjustColorOnOreContent(%this, %case)
{
	if(isObject(%this))
	{
		if(%this.getDatablock().uiName $= "Ore" || %this.getDatablock().uiName $= "Small Ore")
		{
			if(%case == 0)
			{
				%this.schedule(getRandom(60000, 120000), "adjustColorOnOreContent", 1);
				%this.color = getClosestPaintColor("0 0 0 1");
				%this.setColor(%this.color);
			}

			if(%case == 1)
			{
				%seed = getRandom(1, getRandom(1, ResourceSO.mineralCount));
				%this.id = ResourceSO.mineral[%seed].id;
				%this.name = ResourceSO.mineral[%seed].name;
				%this.totalHits = ResourceSO.mineral[%seed].totalHits;
				%this.BPH = ResourceSO.mineral[%seed].BPH;
				%this.color = getClosestPaintColor(ResourceSO.mineral[%seed].color);
				%this.setColor(%this.color);
			}
		}
	}
}

function fxDTSBrick::onMine(%this, %client)
{
	if(%this.totalHits == 1)
	{
		%this.totalHits--;
		%this.adjustColorOnOreContent(0);
		CityRPGData.getData(%client.bl_id).valueResources = getWord(CityRPGData.getData(%client.bl_id).valueResources, 0) SPC (getWord(CityRPGData.getData(%client.bl_id).valueResources, 1) + (%this.BPH * ResourceSO.mineral[%this.id].totalHits)) SPC getWord(CityRPGData.getData(%client.bl_id).valueResources, 2);
		%client.SetInfo();
		return;
	}

	if(%this.totalHits > 0)
	{
		%this.totalHits--;

		%col1 = "\c6";
		%col2 = "\c3";
		%client.centerPrint("<just:left>" @ $CityRPG::MainFont @ %col1 @ %this.name @ %col2 @ ":" SPC %this.totalHits, 3);
				
		if(getRandom(1, 100) > 100 - (CityRPGData.getData(%client.bl_id).valueEducation / 2))
			%gemstone = true;
				
		if(%gemstone)
		{
			%value = getRandom(5, 50);
			messageClient(%client, '', "\c6You extracted a gem from the rock worth \c3$" @ %value @ "\c6.");
			CityRPGData.getData(%client.bl_id).valueMoney += %value;
		}
	}

	if(%this.totalHits == 0)
		%client.centerPrint("<just:left>" @ $CityRPG::MainFont @ "\c0Empty");
		
}