datablock AudioProfile(tf2MeleeSwingSound)
{
   filename    = "Add-ons/gamemode_CityRPG/items/baton/tf2MeleeSwing.wav";
   description = AudioClosest3d;
   preload = true;
};

function tf2MeleeWeaponImage::onMount(%this, %obj, %slot)
{
	WeaponImage::onMount(%this, %obj, %slot);
}

function tf2MeleeWeaponImage::onUnMount(%this, %obj, %slot)
{
	WeaponImage::onUnMount(%this, %obj, %slot);
	%obj.playThread(2,root);
}

function tf2MeleeWeaponImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, shiftAway);
}

function tf2MeleeWeaponImage::onFire(%this, %obj, %slot)
{
	WeaponImage::onFire(%this, %obj, %slot);
	%obj.playthread(2, wrench);
}

function tf2MeleeWeaponImage::onStopFire(%this, %obj, %slot)
{	
	//%obj.playthread(2, root);
}

function tf2MeleeWeaponImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
   WeaponImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
}

function tf2MeleeWeaponImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
   WeaponImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
}

function tf2MeleeWeaponImage::isRaycastCritical(%this,%obj,%slot,%col,%pos,%normal,%hit)
{
   if(isObject(%obj) && (%obj.getType() & $TypeMasks::PlayerObjectType) && %col.iszombie)
   {
       return 1;
   }
   return WeaponImage::isRaycastCritical(%this,%obj,%slot,%col,%pos,%normal,%hit);
}

datablock AudioProfile(CityRPGBatonHitSoundA)
{
	filename    = "Add-Ons/Gamemode_CityRPG/items/baton/melee_tonfa_01.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(CityRPGBatonHitSoundB)
{
	filename    = "Add-Ons/Gamemode_CityRPG/items/baton/melee_tonfa_02.wav";
	description = AudioClose3d;
	preload = true;
};

//////////
// item //
//////////
datablock ItemData(CityRPGBatonItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "Add-Ons/Gamemode_CityRPG/items/baton/shape.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Baton";
	iconName = "Add-Ons/Gamemode_CityRPG/items/baton/icon";
	doColorShift = true;
	colorShiftColor = "0.3 0.3 0.35 1.000";

	 // Dynamic properties defined by the scripts
	image = CityRPGBatonImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
AddDamageType("CityRPGBaton",   '<bitmap:Add-Ons/Gamemode_CityRPG/items/baton/ci> %1',    '%2 <bitmap:Add-Ons/Gamemode_CityRPG/items/baton/ci> %1',0.75,1);
datablock ShapeBaseImageData(CityRPGBatonImage)
{
   shapeFile = "Add-Ons/Gamemode_CityRPG/items/baton/shape.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0.0 -0.1 0.0";
   rotation = eulerToMatrix("0 0 0");
   eyeOffset = "0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   className = "TF2MeleeWeaponImage";

   // Projectile && Ammo.
   item = CityRPGBatonItem;
   ammo = " ";
   projectile = hammerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = CityRPGBatonItem.colorShiftColor;
   
   raycastWeaponRange = 4;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastExplosionProjectile = hammerProjectile;
   raycastExplosionBrickSound = CityRPGBatonHitSoundA;
   raycastExplosionPlayerSound = CityRPGBatonHitSoundB;
   raycastDirectDamage = 25;
   raycastDirectDamageType = $DamageType::CityRPGBaton;
   
   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateSequence[0]                 = "Activate";
	stateTransitionOnTimeout[0]      = "Ready";
	stateScript[0]                  = "onActivate";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.05;
	stateTransitionOnTimeout[2]     = "FireA";
	
	stateName[3]                    = "FireA";
	stateTransitionOnTimeout[3]     = "FireB";
	stateTimeoutValue[3]            = 0.10;
	stateAllowImageChange[3]        = false;
	stateSound[3]			= tf2MeleeSwingSound;
	stateScript[3]                  = "onFireB";
	stateWaitForTimeout[3]		= true;

	stateName[4]                    = "FireB";
	stateTransitionOnTimeout[4]     = "Wait";
	stateTimeoutValue[4]            = 0.15;
	stateSequence[4]                 = "Fire";
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]		= true;
	
	stateName[5]			= "Wait";
	stateTransitionOnTimeout[5]	= "CheckFire";
	stateTimeoutValue[5]		= 0.1;
	stateScript[5]			= "onStopFire";
	stateAllowImageChange[5]	= false;
	stateWaitForTimeout[5]		= true;

	stateName[6]			= "CheckFire";
	stateTransitionOnTriggerUp[6]	= "StopFire";
	stateTransitionOnTriggerDown[6]	= "PreFire";
	
	stateName[7]                    = "StopFire";
	stateTransitionOnTimeout[7]     = "Ready";
	stateTimeoutValue[7]            = 0.2;
	stateAllowImageChange[7]        = false;
	stateWaitForTimeout[7]		= true;
	stateSequence[7]                = "StopFire";
	stateScript[7]                  = "onStopFire";
};

function CityRPGBatonImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(2,shiftto);

	if(getRandom(0,1))
	{
		%this.raycastExplosionBrickSound = CityRPGBatonHitSoundA;
		%this.raycastExplosionPlayerSound =meleeHammerSound;
	}
	else
	{
		%this.raycastExplosionBrickSound = CityRPGBatonHitSoundB;
		%this.raycastExplosionPlayerSound =meleeHammerSound;
	}

	WeaponImage::onFire(%this, %obj, %slot);
}

function CityRPGBatonImage::onFireB(%this, %obj, %slot)
{
	//%obj.playthread(2, shiftaway);
}

function CityRPGBatonImage::onActivate(%this, %obj, %slot)
{
	%obj.playthread(2, plant);
}

function CityRPGBatonImage::onHitObject(%this, %obj, %slot, %col, %pos, %normal)
{
	if(%col.getClassName() $= "fxDTSBrick")
	{
		%client = %obj.client;
		%brickData = %col.getDatablock();

		if(%brickData.CityRPGBrickType == 420)
			%col.bagPlant(%client);
	}

	if(%col.getClassName() $= "Player")
	{
		%client = %obj.client;
		if((%col.getType() & $typeMasks::playerObjectType) && isObject(%col.client))
		{
			if(%col.client.getWantedLevel())
			{
				if(%col.getDatablock().maxDamage - (%col.getDamageLevel() + 25) < %this.raycastDirectDamage)
				{
					%col.setDamageLevel(%this.raycastDirectDamage + 1);
					%col.client.arrest(%client);
				}
				else
					commandToClient(%client, 'CenterPrint', "\c3" @ %col.client.name SPC "\c6has resisted arrest!", 3);
			}
			else if(%col.client.getDrugCount())
			{
				if(%col.getDatablock().maxDamage - (%col.getDamageLevel() + 25) < %this.raycastDirectDamage)
				{
					CityRPGData.getData(%col.client.bl_id).valueDemerits += %col.client.getDrugCount() * $CityRPG::Drugs::demWorth;
					%col.setDamageLevel(%this.raycastDirectDamage + 1);
					%col.client.arrest(%client);
				}
				else
				{
					commandToClient(%client, 'CenterPrint', "\c3" @ %col.client.name SPC "\c6is carrying drugs, and is resisting arrest!", 3);
					if(CityRPGData.getData(%col.client.bl_id).valueDemerits < $CityRPG::pref::demerits::wantedLevel)
						CityRPGData.getData(%col.client.bl_id).valueDemerits += ((CityRPGData.getData(%col.client.bl_id).valuetotaldrugs) * $CityRPG::drug::demWorth);
				}
			}
			else if(CityRPGData.getData(%col.client.bl_id).valueBounty > 0)
				commandToClient(%client, 'CenterPrint', "\c3" @ %col.client.name SPC "\c6is not wanted alive.", 3);
			else
				%doNoEvil = true;
		}
	}
	
	if(%doNoEvil) { %this.raycastDirectDamage = 10; }
	parent::onHitObject(%this, %obj, %slot, %col, %pos, %normal);
	if(%doNoEvil) { %this.raycastDirectDamage = 25; }
}