// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Server Preferences
// ============================================================
// Table of Contents
// 1. Basic Preferences
// 2. Price Preferences
// 2.1 Weapon Price Preferences
// 3. Tick Preferences
// 4. Demerit Preferences
// 5. Vehicle Preferences
// 7. Allowed Inmate Items
// 8. Food
// 9. Banned Events
// 10. Hunger Colors and States
// ============================================================

// ============================================================
// Section 1 : Random Preferences
// ============================================================
$CityRPG::pref::demerits::pardonCost = 100;
$CityRPG::pref::demerits::recordShredCost = 5000;
$CityRPG::pref::demerits::demeritCost = 2;

$CityRPG::pref::demerits::demoteLevel = 250;
$CityRPG::pref::demerits::wantedLevel = 50;

$CityRPG::pref::demerits::reducePerTick = 30;
$CityRPG::pref::demerits::minBounty = 200;

$CityRPG::pref::resources::tree::regrowTime = 2.5;
$CityRPG::pref::resources::ore::noOreColorID = 50;
$CityRPG::pref::resources::ore::hasOreColorID = 49;

$CityRPG::pref::realestate::maxLots = 2;

$CityRPG::pref::giveDefaultTools = true;
$CityRPG::pref::defaultTools = "hammerItem wrenchItem printGun";

$CityRPG::pref::moneyDieTime = 60000;

$CityRPG::pref::players::startingCash = 50;

// ============================================================
// Section 2 : Price Preferences
// ============================================================
$CityRPG::prices::vehicleSpawn = 2500;
$CityRPG::prices::jailingBonus = 15;
$CityRPG::prices::reset = 500;
$CityRPG::prices::resourcePrice = 1.25;

// Section 2.1 - Weapon Prices
$CityRPG::guns = 0;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "taserItem";
$CityRPG::prices::weapon::price[$CityRPG::guns] = 20;
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = 10;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_AssaultRifleItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_AssaultRifleSDItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_BattleRifleItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_BattleRifleSDItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_BullpupItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_HandcannonItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_MGItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_PistolItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_PistolSDItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_RevolverItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_ShotgunItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_SMGItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_SMGSDItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_SniperRifleItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_UziItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;

$CityRPG::prices::weapon::name[$CityRPG::guns+=1] = "gc_UziSDItem";
$CityRPG::prices::weapon::namew[$CityRPG::guns] = strReplace($CityRPG::prices::weapon::name[$CityRPG::guns], "Item", "Image");
$CityRPG::prices::weapon::price[$CityRPG::guns] = ($CityRPG::prices::weapon::namew[$CityRPG::guns].directDamage + $CityRPG::prices::weapon::namew[$CityRPG::guns].range + $CityRPG::prices::weapon::namew[$CityRPG::guns].headShotDamage);
$CityRPG::prices::weapon::mineral[$CityRPG::guns] = $CityRPG::prices::weapon::name[$CityRPG::guns].gc_maxmag;


// ============================================================
// Section 3 : Tick Preferences
// ============================================================
$CityRPG::tick::interest = 1.01;
$CityRPG::tick::creditInterest = 1.015;
$CityRPG::tick::interestTick = 12;
$CityRPG::tick::speed = 3;
$CityRPG::tick::promotionLevel = 24;

// ============================================================
// Section 4 : Demerit Preferences
// ============================================================
$CityRPG::demerits::hittingInnocents = 10;
$CityRPG::demerits::attemptedMurder = 25;
$CityRPG::demerits::murder = 75;
$CityRPG::demerits::breakingAndEntering = 10;
$CityRPG::demerits::attemptedBnE = 5;
$CityRPG::demerits::bountyPlacing = 250;
$CityRPG::demerits::bountyClaiming = 500;
$CityRPG::demerits::pickpocketing = 25;
$CityRPG::demerits::bankRobbery = 3000;
$CityRPG::demerits::tasingBros = 25;
$CityRPG::demerits::grandTheftAuto = 75;

// ============================================================
// Section 5 : Vehicle Preferences
// ============================================================
$CityRPG::vehicles::allowSpawn = true;

$CityRPG::vehicles::banned[0] = "FlyingWheeledJeepVehicle";
$CityRPG::vehicles::banned[1] = "MiniJetVehicle";
$CityRPG::vehicles::banned[2] = "StuntPlaneVehicle";
$CityRPG::vehicles::banned[3] = "BiplaneVehicle";
$CityRPG::vehicles::banned[4] = "MagicCarpetVehicle";
$CityRPG::vehicles::banned[5] = "TankVehicle";
$CityRPG::vehicles::banned[6] = "horseArmor";

// ============================================================
// Section 7 : Allowed Inmate Items
// ============================================================
$CityRPG::demerits::jail::image["CityRPGLumberjackImage"] = true;
$CityRPG::demerits::jail::image["CityRPGPickaxeImage"] = true;

// Inmate Spawn Items
$CityRPG::demerits::jail::item[0] = "CityRPGPickaxeItem";

// ============================================================
// Section 8 : Food
// ============================================================
$CityRPG::portion[1] = "Small";
$CityRPG::portion[2] = "Medium";
$CityRPG::portion[3] = "Large";
$CityRPG::portion[4] = "Extra_Large";
$CityRPG::portion[5] = "Super_Sized";
$CityRPG::portion[6] = "Americanized";

// ============================================================
// Section 9 : Banned Events
// ============================================================
unRegisterOutputEvent("fxDTSBrick", "RadiusImpulse");
unRegisterOutputEvent("fxDTSBrick", "SetItem");
unRegisterOutputEvent("fxDTSBrick", "SetItemDirection");
unRegisterOutputEvent("fxDTSBrick", "SetItemPosition");
unRegisterOutputEvent("fxDTSBrick", "SetVehicle");
unRegisterOutputEvent("fxDTSBrick", "SpawnExplosion");
unRegisterOutputEvent("fxDTSBrick", "SpawnItem");
unRegisterOutputEvent("fxDTSBrick", "SpawnProjectile");	

unRegisterOutputEvent("Player", "AddHealth");
unRegisterOutputEvent("Player", "AddVelocity");
unRegisterOutputEvent("Player", "BurnPlayer");
unRegisterOutputEvent("Player", "ChangeDatablock");
unRegisterOutputEvent("Player", "ClearBurn");
unRegisterOutputEvent("Player", "ClearTools");
unRegisterOutputEvent("Player", "Dismount");
unRegisterOutputEvent("Player", "InstantRespawn");
unRegisterOutputEvent("Player", "Kill");
unRegisterOutputEvent("Player", "SetHealth");
unRegisterOutputEvent("Player", "SetPlayerScale");
unRegisterOutputEvent("Player", "SetVelocity");
unRegisterOutputEvent("Player", "SpawnExplosion");
unRegisterOutputEvent("Player", "SpawnProjectile");

unRegisterOutputEvent("GameConnection", "IncScore");
unRegisterOutputEvent("GameConnection", "ChatMessage");

unRegisterOutputEvent("MiniGame", "BottomPrintAll");
unRegisterOutputEvent("MiniGame", "CenterPrintAll");
unRegisterOutputEvent("MiniGame", "ChatMsgAll");
unRegisterOutputEvent("MiniGame", "Reset");
unRegisterOutputEvent("MiniGame", "RespawnAll");

// ============================================================
// Section 10 : Hunger Colors and States
// ============================================================
$CityRPG::food::stateCount = 0;

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FF0000";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Starving";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FF6600";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Hungry";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FFBB00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Content";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "FFFF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Satisfied";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "DDFF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Full-up";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "AAFF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Overfed";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "88FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Stuffed";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "66FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Bloated";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "44FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Bloated";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "22FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Engorged";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "00FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Disgusting";

$CityRPG::food::color[$CityRPG::food::stateCount++] = "00FF00";
$CityRPG::food::state[$CityRPG::food::stateCount] = "Disgusting";

// ===============================================================
// Section: 10 Reg Prefs
// ===============================================================
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	
	// City Prefs
	RTB_registerPref("Pardon Cost", "Iban's CityRPG", "$CityRPG::pref::demerits::pardonCost", "int 0 100000", "Gamemode_CityRPG", $CityRPG::pref::demerits::pardonCost, 0, 0);
	RTB_registerPref("Max Lots", "Iban's CityRPG", "$CityRPG::pref::realestate::maxLots", "int 0 9999999", "GameMode_CityRPG", $CityRPG::pref::realestate::maxLots, 0, 0);
	RTB_registerPref("Min Bounty", "Iban's CityRPG", "$CityRPG::pref::demerits::minBounty", "int 0 1000", "GameMode_CityRPG", $CityRPG::pref::demerits::minBounty, 0, 0);
	RTB_registerPref("Jailing Bonus", "Iban's CityRPG", "$CityRPG::prices::jailingBonus", "int 0 150", "GameMode_CityRPG", $CityRPG::prices::jailingBonus, 0, 0);
	RTB_registerPref("Reset Cost", "Iban's CityRPG", "$CityRPG::prices::reset", "int 0 50000", "GameMode_CityRPG", $CityRPG::prices::reset, 0, 0);
	RTB_registerPref("Tick Speed", "Iban's CityRPG", "$CityRPG::tick::speed", "int 0 10", "GameMode_CityRPG", $CityRPG::tick::speed, 0, 0);
	RTB_registerPref("Crime | Demerit Cost", "Iban's CityRPG", "$CityRPG::pref::demerits::demeritCost", "int 0 10", "GameMode_CityRPG", $CityRPG::pref::demerits::demeritCost, 0, 0);
	RTB_registerPref("Crime | Wanted Level", "Iban's CityRPG", "$CityRPG::pref::demerits::wantedLevel", "int 0 300", "GameMode_CityRPG", $CityRPG::pref::demerits::wantedLevel, 0, 0);
	RTB_registerPref("Crime | Hitting Innocents", "Iban's CityRPG", "$CityRPG::demerits::hittingInnocents", "int 0 5000", "GameMode_CityRPG", $CityRPG::demerits::hittingInnocents, 0, 0);
	RTB_registerPref("Crime | Attempted Murder", "Iban's CityRPG", "$CityRPG::demerits::attemptedMurder", "int 0 5000", "GameMode_CityRPG", $CityRPG::demerits::attemptedMurder, 0, 0);
	RTB_registerPref("Crime | Murder", "Iban's CityRPG", "$CityRPG::demerits::murder", "int 0 5000", "GameMode_CityRPG", $CityRPG::demerits::murder, 0, 0);
	RTB_registerPref("Crime | Breaking & Entering", "Iban's CityRPG", "$CityRPG::demerits::breakingandentering", "int 0 5000", "GameMode_CityRPG", $CityRPG::demerits::breakingandentering, 0, 0);
	RTB_registerPref("Crime | Tasing Innocents", "Iban's CityRPG", "$CityRPG::demerits::tasingBros", "int 0 5000", "GameMode_CityRPG", $CityRPG::demerits::tasingBros, 0, 0);
	RTB_registerPref("Crime | Placeing Bounty", "Iban's CityRPG", "$CityRPG::demerits::bountyPlacing", "int 0 5000", "GameMode_CityRPG", $CityRPG::demerits::bountyPlacing, 0, 0);
	RTB_registerPref("Crime | Claiming Bounty", "Iban's CityRPG", "$CityRPG::demerits::bountyClaiming", "int 0 5000", "GameMode_CityRPG", $CityRPG::demerits::bountyClaiming, 0, 0);
	RTB_registerPref("Crime | Pick Pocket", "Iban's CityRPG", "$CityRPG::demerits::pickpocketing", "int 0 5000", "GameMode_CityRPG", $CityRPG::demerits::pickpocketing, 0, 0);
	RTB_registerPref("Crime | Garnd Theft Auto", "Iban's CityRPG", "$CityRPG::demerits::grandtheftauto", "int 0 5000", "GameMode_CityRPG", $CityRPG::demerits::grandtheftauto, 0, 0);
}